



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HITOJ 2662 Pieces Assignment（状压DP）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HITOJ 2662 Pieces Assignment（状压DP）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 10:24:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Pieces Assignment</h1>
<div>
<table>
<tbody>
<tr>
<th>My Tags</th>
<td>&nbsp;&nbsp;(Edit)</td>
</tr>
</tbody>
</table>
</div>
<div>
<div>
<table>
<tbody>
<tr>
<td>&nbsp;</td>
<td colspan="3">Source&nbsp;:&nbsp;<a href="http://acm.hit.edu.cn/hoj/problem/view?id=zhouguyue" rel="external nofollow noreferrer">zhouguyue</a></td>
</tr>
<tr>
<td>&nbsp;</td>
<td>Time limit&nbsp;: 1 sec</td>
<td>&nbsp;</td>
<td>Memory limit&nbsp;: 64 M</td>
</tr>
</tbody>
</table>
</div>
<div>
<p>Submitted&nbsp;: 539,&nbsp;Accepted&nbsp;: 190</p>
</div>
</div>
<div>
<h3>Background</h3>
<p>有一个n*m的棋盘(n、m&le;80,n*m&le;80)要在棋盘上放k(k&le;20)个棋子，使得任意两个棋子不相邻（每个棋子最多和周围4个棋子相邻）。求合法的方案总数。</p>
<h3>Input</h3>
<p>本题有多组测试数据，每组输入包含三个正整数n,m和k。</p>
<h3>Output</h3>
<p>对于每组输入，输出只有一个正整数，即合法的方案数。</p>
<h3>Sample Input</h3>
<pre class="prettyprint linenums">2 2 3<br />
4 4 1
</pre>
<h3>Sample Output</h3>
<pre class="prettyprint linenums">0<br />
16</pre>
</div>
<p>题目链接：<a href="http://acm.hit.edu.cn/hoj/problem/view?id=2662" rel="external nofollow noreferrer">HITOJ 2662</a></p>
<p>由于实验室内大神讲了高大上的状压DP，于是就就去看了一下，感觉还是比较好理解的，就是感觉状态转移对于我这种还没入门的就比较难想到了&hellip;&hellip;</p>
<p>dp[i][j][k]表示当前已遍历过i行，总共用了j个棋子，且最后一行摆放状态为k的方案数，然后就是如何进行状态的转移呢？首先DP总得要初始化的吧，先考虑只有一行的情况（实际上初始化的时候可以把所有合法的行状态都保存下来方便之后遍历），一行里的方案数就只需要初始化dp[1][j][k<sub>1</sub>]</p>
<p>把一行看成m个位置，每一个位置都是0或1，1表示放了棋子，0表示没放，比如一行3个棋子，可以是这样101、110、010、000、111（二进制）等等，如何判断当前摆放情况是否合法呢，这里要用到位运算&amp;，即当前的状态转换成10进制进行&amp;运算，sta&amp;(sta&lt;&lt;1)，可以发现若存在两个或以上1相邻的情况，按位与的结果必定不为0即不合法，然后在不知道如何摆放的情况下遍历所有可能的方案，上面的例子三个位置一共有2*2*2=8种情况，分别是011、101、110、100、010、001、111、000，但其实把n位全部填满最多只会达到2<sup>n</sup>-1因此可以for (i=0; i&lt;=(1&lt;&lt;)-1; ++i)，然后把每一个行状态判断一下并保存在合法状态的集合里，然后对每一行都进行判断，</p>
<p>转移方程就是dp[i][j][k<sub>1</sub>]+=dp[i-1][j-这一行二进制状态所含1的个数count][k<sub>2</sub>]（j&gt;=count&amp;&amp;k1与k2不冲突）</p>
<p>代码：</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;cstdlib&gt;<br />
#include &lt;sstream&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;bitset&gt;<br />
#include &lt;string&gt;<br />
#include &lt;deque&gt;<br />
#include &lt;stack&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;set&gt;<br />
#include &lt;map&gt;<br />
using namespace std;<br />
#define INF 0x3f3f3f3f<br />
#define CLR(arr,val) memset(arr,val,sizeof(arr))<br />
#define LC(x) (x&lt;&lt;1)<br />
#define RC(x) ((x&lt;&lt;1)+1)<br />
#define MID(x,y) ((x+y)&gt;&gt;1)<br />
typedef pair&lt;int,int&gt; pii;<br />
typedef long long LL;<br />
const double PI=acos(-1.0);<br />
const int M=1&lt;&lt;9;<br />
LL dp[82][22][M];//第i行、用了j个棋子、状态为第k个<br />
int status[M];

inline bool check(const int &amp;a,const int &amp;b)<br />
{<br />
    return (a&amp;b)==0;//这里要加括号，==的优先级比&amp;高<br />
}

int main(void)<br />
{<br />
    int n,m,k,i,j,pre,cur;<br />
    while (~scanf("%d%d%d",&amp;n,&amp;m,&amp;k))<br />
    {<br />
        CLR(dp,0);<br />
        if(m&gt;n)//m保持较小<br />
            swap(n,m);

        int legalcnt=0;<br />
        int totalsta=(1&lt;&lt;m)-1;<br />
        for (i=0; i&lt;=totalsta; ++i)<br />
        {<br />
            if(check(i,i&gt;&gt;1))<br />
            {<br />
                dp[1][bitset&lt;10&gt;(i).count()][legalcnt]=1LL;<br />
                status[legalcnt++]=i;<br />
            }<br />
        }<br />
        for (i=2; i&lt;=n; ++i)<br />
        {<br />
            for (j=0; j&lt;=k; ++j)<br />
            {<br />
                for (cur=0; cur&lt;legalcnt; ++cur)<br />
                {<br />
                    for(pre=0; pre&lt;legalcnt; ++pre)<br />
                    {<br />
                        int curuse=bitset&lt;10&gt;(status[cur]).count();<br />
                        if(check(status[pre],status[cur])&amp;&amp;j&gt;=curuse)<br />
                        {<br />
                            dp[i][j][cur]+=dp[i-1][j-curuse][pre];<br />
                        }<br />
                    }<br />
                }<br />
            }<br />
        }<br />
        LL r=0;<br />
        for (i=0; i&lt;legalcnt; ++i)<br />
            r+=dp[n][k][i];<br />
        printf("%lld\n",r);<br />
    }<br />
    return 0;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqve1ez9.html">Git分布式版本控制学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evx2m9.html">用C&num;通过反射实现动态调用WebService 告别Web引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prejzq.html">Erwin 生成 mysql 带注释&lpar;comment &rpar;的脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1y4le9.html">使用变量替换批量部署GoldenGate</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06z0lq.html">8-11-Exercise</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1g64k9.html">NYOJ-104最大和</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrpyvq.html">浅谈C中的指针和数组（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwjej8.html">交互设计师谈颠覆式创新 &vert; Think different</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkno2z8.html">delpi中的RTTI初试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdy7wz9.html">awk使用方法与案例介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4y0g8.html">BlackArch安装（译文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwvo79.html">yyb博客的几道神仙题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6yvr8.html">PERFECT NUMBER PROBLEM（思维）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv1klx8.html">Defender 防卫者</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1nnj49.html">bzoj1875 边点互换&plus;矩乘</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15rg5q.html">constructor与prototype</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvrlnz8.html">Centos7常用操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj5yn79.html">AYUI7  WPF MVC插件欣赏</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rymko9.html">&lbrack;原&rsqb;Jenkins&lpar;十九&rpar; jenkins再出发之jenkins邮件通知</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyygnjxq.html">angular中的MVC思想</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jkdzl8.html">【python】队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/390oklj9.html">MFC 相关文件夹、文件操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyp07gq.html">Shallow Size 和 Retained Size</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1e2p59.html">oracle 序列 详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ed71z9.html">Maven使用笔记（二）Eclipse中maven项目添加依赖</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2r10v9.html">Struts2 Struts&period;xml DTD 说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw6yry9.html">JS中使用EL表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o7rw1q.html">adb 卸载APP命令和杀死APP命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9352drq.html">FPGA学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyp7zdq.html">include、include&lowbar;once与require、require&lowbar;once区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
